% IPLPLAN.PRG.PRO: Generic planner.
% A plan is assembled as a list -
%   advantages w.r.t. building a nesting of predicates 
%   (see biblio/technologie/informatie/prolog/planner_warren.pro): 
%   faster and more comprehensible.
% Author: Frans A.Meijs, feb 2017.
  
iplPlanSolution(P) :-
    provisionalPlan(P),
    ~( incompleteProvisionalPlan(P) ),
    assert( plan(P) ),
    W = 'Objectworld',
    assert( structuralUnit__isPrivateElementOf_su(P, W) ).  % Note 1.

provisionalPlan([A]) :-
    activitySpec(A),
    activitySpec__promises_deliverable(A, D),
    ~( activitySpec__requires_deliverable(_, D) ).
                          % A branch to the final root of the plan.
provisionalPlan([A|P]) :-
    activitySpec(A),
    activitySpec__promises_deliverable(A, D),
    plan__requires_deliverable(P, D),
    provisionalPlan(P).

plan__requires_deliverable([A|_], D) :-
    activitySpec(A),
    activitySpec__requires_deliverable(A, D).
    
incompleteProvisionalPlan([A|_]) :-
    activitySpec__requires_deliverable(A, D),
    activitySpec__promises_deliverable(_, D),
    !.                     % Solution is sufficient.
    
% Notes
% 1. assert( structuralUnit__isPrivateElementOf_su(P, 'Objectworld') )
%    does not work in SwiProlog.

