% iplplan_r.prg.pro - plan details reporting program, general part.

o_planReport :-
    toFile(TF),			% TO BE DEFINED BY CALLER.
    tell(TF),
    o_planReport_v2,
    told,
    o_chars('Rapport is in doc '),
    o_chars(TF),
    o_eor.

o_planReport_v2 :-
    setofall(P,plan(P),P_LIST),
    setofall(PR,processor(PR),PR_LIST),
    o_plan_reportList(P_LIST),
    o_planProcessor_reportList(PR_LIST).
    
o_plan_reportList([]).
o_plan_reportList([P|P_LIST]) :-
       % Object implications 
   o_chars('Plan component: '),
   o_chars(P),
   o_eor,
   o_plan_reportList(P_LIST).   

o_planProcessor_reportList([]).
o_planProcessor_reportList([P|P_LIST]) :-
   totalRequiredEffort__e_processor(TRE, P),
       % Object implications 
   o_chars('Processor '),
   o_chars(P),
   o_tab(30),
   o_chars('totaal vereiste inspanning '),
   o_chars(TRE),
   o_eor,
   o_planProcessor_reportList(P_LIST).

totalRequiredEffort__e_processor(TRE, P) :-
   nonvar(P),
   bagofall(RE,
      requiredEffort__e_processor(RE, P),
      RE_LIST),
   numList__has_sum(RE_LIST, TRE).

requiredEffort__e_processor(RE, P) :-
   nonvar(P),
   activitySpec__requires_processor(A, P),
   activitySpec__requires_effort(A, RE).

 
:- getfullpath('IPL_FM','/applications/iplm_pro.prg',X), consult(X). 

:- getfullpath('IPL_FM','/applications/iplm_prp.prg',X), consult(X). 
:- getfullpath('IPL_FM','/applications/iplm_met.prg',X), consult(X). 
%:- getfullpath('PROLOG_FM','/applications/prol_fm.pl',X), consult(X). 
    % (Already loaded)

?- o_planReport.                        % Should be last because it is immediate.




