% PROJ_AUX.PRO: Auxiliary clauses, for validation etc.

totalContractedManWeekEffort__e_person__in_project(TCMWE, P, PT) :-
   person(P),
   project(PT),
   bagofall(CMWE,
      contractedManWeekEffort__e_person__in_project(CMWE, P, PT),
      CMWE_LIST),
   numList__has_sum(CMWE_LIST, TCMWE).


contractedManWeekEffort__e_person__in_project(RWE, P, PT) :-
   nonvar(P),
   nonvar(PT),
   projectActivity__e_project(PA, PT),
   person__e_projectActivity(P, PA),
   projectActivity__mapsTo_milestone(PA, M),
   requiredManWeekEffort__e_milestone(RWE, M).


projectActivity__begins_at_date(PA, D) :-
   projectActivity(PA),
   projectActivity__mapsFrom_milestone(PA, M),
   relWeekno__e_milestone(RWN, M),
   projectActivity__e_project(PA, P),
   beginDate__e_project(D2, P),
   INCR is (RWN - 1) * 7,
   date__incrBy_nat__is_date(D2, INCR, D).
   

projectActivity__ends_at_date(PA, D) :-
   projectActivity(PA),
   projectActivity__mapsTo_milestone(PA, M),
   relWeekno__e_milestone(RWN, M),
   projectActivity__e_project(PA, P),
   beginDate__e_project(D2, P),
   INCR is (RWN - 1) * 7,
   date__incrBy_nat__is_date(D2, INCR, D).


cost__isAttributeOf_connection(C, PA) :-
   projectActivity__mapsFrom_milestone(PA, M1),
   relWeekno__e_milestone(RWN1, M1),
   projectActivity__mapsTo_milestone(PA, M2),
   relWeekno__e_milestone(RWN2, M2),
   C is RWN2 - RWN1.



endConnection(C) :-
    connection__connectsTo_node(C, N),
    ~( connection__connectsFrom_node(_, N) ).


%:- consult('date.pro').
