% PROJECT.PRO: Abstractions about projects

process(P) :- project(P).
            % Is essentially an instance of a class of DSSB, but I did
            % not find it worthwile the effort to model it as such.
attrDiNet(P) :- project(P).
mapping(PA) :- projectActivity(PA).
entity(PA) :- projectActivity(PA).
            % Necessary for aggregating attributes which are not
            % milestone specific.
entity(M) :- milestone(M).
            % A mapping in a process should map from/to only one state,
            % so all concepts where should be mapped from/to are aggregated
            % into milestones.


concept__isExplicitlyElementOf_set(D,P) :-
   beginDate__e_project(D, P).
            % A project is a network, no entity.
concept__isExplicitlyElementOf_set(RWN,M) :-
   relWeekno__isExplicitlyElementOf_milestone(RWN, M).


mapping__e_process(PA, P) :-
   projectActivity__e_project(PA, P).


entity__isPrivateElementOf_entity(D, M) :-
   deliverable__e_milestone(D, M).
entity__isShareableElementOf_entity(PC, PA) :-
   person__e_projectActivity(PC, PA).


elemState__e_entity(RWN, M) :-
   relWeekno__e_milestone(RWN, M).
elemState__e_entity(MWE, M) :-
   requiredManWeekEffort__e_milestone(MWE, M).
elemState__e_entity(RS, M) :-
   requiredSpecialism__e_milestone(RS, M).


mapping__mapsFrom_state(PA, M) :-
   projectActivity__mapsFrom_milestone(PA, M).
   

mapping__mapsTo_state(PA, M) :-
   projectActivity__mapsTo_milestone(PA, M).


relWeekno__e_milestone(RWN, M) :-
   relWeekno__isExplicitlyElementOf_milestone(RWN, M).
relWeekno__e_milestone(RWN, M) :-
   nonvar(M),
   projectActivity__mapsTo_milestone(PA, M),
   projectActivity__mapsFrom_milestone(PA, M2),
   ~( relWeekno__isExplicitlyElementOf_milestone(_, M2) ),
   relWeekno__e_milestone(RWN2, M2),
   requiredManWeekEffort__e_milestone(MWE, M),
   RWN is RWN2 + MWE.


%:- consult('proj_aux.pro').
%:- consult('project.prc').
